<?php
class plgHikashopCustom_order_export extends JPlugin
{
	var $message = '';

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		$this->massaction = hikashop_get('class.massaction');
		$this->massaction->datecolumns = array( 'order_created',
												'order_modified',
												'user_created'
											);
		$this->order = hikashop_get('class.order');
		$this->db = JFactory::getDBO();
	}

	function onMassactionTableActionsLoad(&$table,&$actions,&$actions_html,&$loadedData){
		if($table->table == 'order'){
			$db = JFactory::getDBO();
			$massactionClass = hikashop_get('class.massaction');
			$type = 'action';

			$actions['customCsv']=JText::_('CUSTOM_CSV_EXPORT');

			$dispTables = array('user','order','address','order_product','joomla_users');
			$checkedDefault = 	array(
									'user'=>
										array('user_id','user_email','user_created_ip','user_created'),
									'order'=>
										array('order_status','order_type','order_number','order_created','order_modified','order_invoice_created','order_payment_method','physicians_city','physicians_firstname','rx_options','contact_doctor_heading','rx_heading','rx_upload','rx_disclaimer','doctor_phone'),
									'address'=>
										array('address_title','address_firstname','address_middle_name','address_lastname','address_company','address_street','address_street2','address_post_code','address_city','address_telephone','address_telephone2','address_fax','address_state','address_country'),
									'order_product'=>
										array('order_product_quantity','order_product_name','order_product_code','order_product_price'),
									'joomla_users'=>
										array()
								);

			$loadedData->massaction_actions['__num__'] = new stdClass();
			$loadedData->massaction_actions['__num__']->type = $table->table;
			$loadedData->massaction_actions['__num__']->data = array('path'=>'');
			$loadedData->massaction_actions['__num__']->name = 'customCsv';
			$loadedData->massaction_actions['__num__']->html = '';
			foreach($loadedData->massaction_actions as $key => &$value) {
				if($value->name != 'customCsv' || ($table->table != $loadedData->massaction_table && is_int($key)))
					continue;
				if(!isset($value->data['formatExport']['path'])) $value->data['formatExport']['path'] = '';
				if(!isset($value->data['formatExport']['email'])) $value->data['formatExport']['email'] = '';
				$output='';
				$margin = '';
				$customCheckboxes='';

				foreach($dispTables as $relatedTable){
					if(version_compare(JVERSION,'3.0','<')){
						if(preg_match('/joomla_/',$relatedTable)) $fieldsTable = $db->getTableFields('#__'.str_replace('joomla_','',$relatedTable));
						else $fieldsTable = $db->getTableFields('#__hikashop_'.$relatedTable);
						$fields = reset($fieldsTable);
					} else {
						if(preg_match('/joomla_/',$relatedTable)) $fields = $db->getTableColumns('#__'.str_replace('joomla_','',$relatedTable));
						else $fields = $db->getTableColumns('#__hikashop_'.$relatedTable);
					}
					if(!empty($fields)) {
						$output .= '<div id="action_'.$table->table.'_'.$key.'_customCsv_'.$relatedTable.'Column_div" class="hika_massaction_checkbox"> <a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_'.$relatedTable.'Column_div\',\'check\');">'.JText::_('SELECT_ALL').'</a> / <a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_'.$relatedTable.'Column_div\',\'uncheck\');">'.JText::_('UNSELECT_ALL').'</a> <br/>';

						if($relatedTable == 'user'){
							$checked='checked="checked"';
							if(!empty($value->data[$relatedTable]) && !isset($value->data['user']['cust_id'])){
								$checked='';
							}
							$output.='<input type="checkbox" '.$checked.' id="action_'.$table->table.'_'.$key.'_customCsv_'.$relatedTable.'Column_cust_id" name="action['.$table->table.']['.$key.'][customCsv]['.$relatedTable.'][cust_id]" /><label style="width: 100%;" for="action_'.$table->table.'_'.$key.'_customCsv_'.$relatedTable.'Column_cust_id">Cust_ID</label><br/>';
						}

						foreach($fields as $key2 => $field){
							if(empty($value->data[$relatedTable]) && in_array($key2,$checkedDefault[$relatedTable]))
								$checked='checked="checked"';
							else if((isset($value->data[$relatedTable]) && isset($value->data[$relatedTable][$key2])))
								$checked='checked="checked"';
							else
								$checked='';
							$output .= '<input type="checkbox" '.$checked.' id="action_'.$table->table.'_'.$key.'_customCsv_'.$relatedTable.'Column_'.$key2.'" name="action['.$table->table.']['.$key.'][customCsv]['.$relatedTable.']['.$key2.']" value="'.$key2.'" /><label style="width: 100%;" for="action_'.$table->table.'_'.$key.'_customCsv_'.$relatedTable.'Column_'.$key2.'">'.$key2.'</label><br/>';
						}
						if($relatedTable == 'price'){
							if(isset($value->data[$relatedTable]) && isset($value->data[$relatedTable]['price_value_with_tax'])){
								$checked='checked="checked"';
							}
							$output .= '<input type="checkbox" '.$checked.' id="action_'.$table->table.'_'.$key.'_customCsv_'.$relatedTable.'Column_price_value_with_tax" name="action['.$table->table.']['.$key.'][customCsv]['.$relatedTable.'][price_value_with_tax]" value="price_value_with_tax" /><label style="width: 100%;" for="action_'.$table->table.'_'.$key.'_customCsv_'.$relatedTable.'Column_price_value_with_tax">price_value_with_tax</label><br/>';
						}
						$output .= '</div>';
						$margin = 'margin-left: 20px;';
					}
				}

				switch($table->table){
					case 'product':
						// Images
						$db->setQuery('SHOW COLUMNS FROM '.hikashop_table('file'));
						$imageColumns = $db->loadObjectList();
						$customCheckboxes .= '<div id="action_'.$table->table.'_'.$key.'_customCsv_filesColumn_div" class="hika_massaction_checkbox"><a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_filesColumn_div\',\'check\');">'.JText::_('SELECT_ALL').'</a> / <a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_filesColumn_div\',\'uncheck\');">'.JText::_('UNSELECT_ALL').'</a><br/><b>'.JText::_('FILES').'</b><br/>';
						foreach($imageColumns as $imageColumn){
							$checked='';
							if(isset($value->data['files'][$imageColumn->Field])){
								$checked='checked="checked"';
							}
							$customCheckboxes .= '<input type="checkbox" '.$checked.' id="action_'.$table->table.'_'.$key.'_customCsv_filesColumn_'.$imageColumn->Field.'" name="action['.$table->table.']['.$key.'][customCsv][files]['.$imageColumn->Field.']" value="'.$imageColumn->Field.'" /><label style="width: 100%;" for="action_'.$table->table.'_'.$key.'_customCsv_filesColumn_'.$imageColumn->Field.'">'.$imageColumn->Field.'</label><br/>';
						}
						$customCheckboxes .= '</div>';

						// Files
						$db->setQuery('SHOW COLUMNS FROM '.hikashop_table('file'));
						$imageColumns = $db->loadObjectList();
						$customCheckboxes .= '<div id="action_'.$table->table.'_'.$key.'_customCsv_imagesColumn_div" class="hika_massaction_checkbox"><a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_imagesColumn_div\',\'check\');">'.JText::_('SELECT_ALL').'</a> / <a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_imagesColumn_div\',\'uncheck\');">'.JText::_('UNSELECT_ALL').'</a><br/><b>'.JText::_('IMAGES').'</b><br/>';
						foreach($imageColumns as $imageColumn){
							$checked='';
							if(isset($value->data['images'][$imageColumn->Field])){
								$checked='checked="checked"';
							}
							$customCheckboxes .= '<input type="checkbox" '.$checked.' id="action_'.$table->table.'_'.$key.'_customCsv_imagesColumn_'.$imageColumn->Field.'" name="action['.$table->table.']['.$key.'][customCsv][images]['.$imageColumn->Field.']" value="'.$imageColumn->Field.'" /><label style="width: 100%;" for="action_'.$table->table.'_'.$key.'_customCsv_imagesColumn_'.$imageColumn->Field.'">'.$imageColumn->Field.'</label><br/>';
						}
						$customCheckboxes .= '</div>';

						// Characteristic
						$db->setQuery('SELECT * FROM '.hikashop_table('characteristic').' WHERE characteristic_parent_id = 0');
						$characteristics = $db->loadObjectList();
						if(is_array($characteristics)){
							$customCheckboxes .= '<div id="action_'.$table->table.'_'.$key.'_customCsv_characteristicColumn_div" class="hika_massaction_checkbox"><a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_characteristicColumn_div\',\'check\');">'.JText::_('SELECT_ALL').'</a> / <a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_characteristicColumn_div\',\'uncheck\');">'.JText::_('UNSELECT_ALL').'</a><br/>';
							foreach($characteristics as $characteristic){
								$checked='';
								if(isset($value->data['characteristic'][$characteristic->characteristic_value])){
									$checked='checked="checked"';
								}
								$customCheckboxes .= '<input type="checkbox" '.$checked.' id="action_'.$table->table.'_'.$key.'_customCsv_characteristicColumn_'.$characteristic->characteristic_value.'" name="action['.$table->table.']['.$key.'][customCsv][characteristic]['.$characteristic->characteristic_value.']" value="'.$characteristic->characteristic_value.'" /><label style="width: 100%;" for="action_'.$table->table.'_'.$key.'_customCsv_characteristicColumn_'.$characteristic->characteristic_value.'">'.$characteristic->characteristic_value.'</label><br/>';
							}
							$customCheckboxes .= '</div>';
						}
						// Product related
						$db->setQuery('SELECT * FROM '.hikashop_table('product_related'));
						$relateds = $db->loadObjectList();
						if(is_array($relateds)){
							$customCheckboxes .= '<div id="action_'.$table->table.'_'.$key.'_customCsv_relatedColumn_div" class="hika_massaction_checkbox"><a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_relatedColumn_div\',\'check\');">'.JText::_('SELECT_ALL').'</a> / <a style="cursor: pointer;" onclick="checkAll(\'action_'.$table->table.'_'.$key.'_customCsv_relatedColumn_div\',\'uncheck\');">'.JText::_('UNSELECT_ALL').'</a><br/>';
							$displayed = array();
							foreach($relateds as $related){
								$checked='';
								if(isset($value->data['related'][$related->product_related_type])){
									$checked='checked="checked"';
								}
								if(!in_array($related->product_related_type, $displayed))
									$customCheckboxes .= '<input type="checkbox" '.$checked.' id="action_'.$table->table.'_'.$key.'_customCsv_relatedColumn_'.$related->product_related_type.'" name="action['.$table->table.']['.$key.'][customCsv][related]['.$related->product_related_type.']" value="'.$related->product_related_type.'" /><label style="width: 100%;" for="action_'.$table->table.'_'.$key.'_customCsv_relatedColumn_'.$related->product_related_type.'">'.$related->product_related_type.'</label><br/>';
								$displayed[] = $related->product_related_type;
							}
							$customCheckboxes .= '</div>';
						}

						break;
					case 'user':
						$checked='';
						if(isset($value->data['usergroups'])){
							$checked='checked="checked"';
						}
						$customCheckboxes .= '<div class="hika_massaction_checkbox">';
						$customCheckboxes .= '<input type="checkbox" '.$checked.' id="action_'.$table->table.'_'.$key.'_customCsv_usergroupsColumn_title" name="action['.$table->table.']['.$key.'][customCsv][usergroups][title]" value="usergroups" /><label style="width: 100%;" for="action_'.$table->table.'_'.$key.'_customCsv_usergroupsColumn_title">'.JText::_('GROUP_NAME').'</label><br/>';
						$customCheckboxes .= '</div>';
						break;
				}

				$output .= $customCheckboxes;
				$output .= '<div style="clear:both;"></div>';
				$checked='';
				if(isset($value->data['formatExport']['format']) && $value->data['formatExport']['format']=='xls')
					$checked='checked="checked"';
				$output .='<input type="radio" id="action'.$table->table.''.$key.'customCsvformatExportformatcsv" name="action['.$table->table.']['.$key.'][customCsv][formatExport][format]" checked value="csv"> <label for="action'.$table->table.''.$key.'customCsvformatExportformatcsv">'.JText::_('CSV').'</label> <input type="radio" id="action'.$table->table.''.$key.'customCsvformatExportformatxls" name="action['.$table->table.']['.$key.'][customCsv][formatExport][format]" '.$checked.' value="xls"> <label for="action'.$table->table.''.$key.'customCsvformatExportformatxls">'.JText::_('XLS').'</label>';
				$output .= '<br/>'.JText::_('EXPORT_PATH').': <input type="text" name="action['.$table->table.']['.$key.'][customCsv][formatExport][path]" value="'.$value->data['formatExport']['path'].'" />';
				$output .= '<br/>'.JText::_('TO_ADDRESS').': <input type="text" name="action['.$table->table.']['.$key.'][customCsv][formatExport][email]" value="'.$value->data['formatExport']['email'].'" /> '.JText::_('FILL_PATH_TO_USE_EMAIL');
				$output .= '<div style="clear:both;"></div>';

				$actions_html[$value->name] = $massactionClass->initDefaultDiv($value, $key, $type, $table->table, $loadedData, $output);
			}
		}
	}

	function onProcessOrderMassActioncustomCsv(&$elements,&$action,$k){
		$massactionClass = hikashop_get('class.massaction');
		$formatExport = $action['formatExport']['format'];
		$path = $action['formatExport']['path'];
		$email = $action['formatExport']['email'];
		if(empty($path)){
			ob_get_clean();
		}
		$app = JFactory::getApplication();
		if($app->isAdmin() || (!$app->isAdmin() && !empty($path))){
			$params = new stdClass();
			$params->action['order']['order_id'] = 'order_id';
			unset($action['formatExport']);

			$custId = false;
			if(isset($action['user']['cust_id'])){
				unset($action['user']['cust_id']);
				$custId = true;
			}

			$params = $massactionClass->_displayResults('order',$elements,$action,$k);

			if($custId && isset($action['address']['address_firstname']) && isset($action['address']['address_lastname']) && isset($action['address']['address_post_code'])){
				foreach($params->elements as $k => $element){
					foreach($element->user as $l => $user){
						foreach($params->elements[$k]->address as $m => $address){
							if($address->address_id == $params->elements[$k]->order_billing_address_id){
								$userObject = clone($params->elements[$k]->user[$l]);
								unset($params->elements[$k]->user[$l]);
								$params->elements[$k]->user[$l] = new stdClass();
								$params->elements[$k]->user[$l]->cust_id = $address->address_lastname.'-'.$address->address_firstname.'-'.$address->address_post_code;
								foreach($userObject as $key => $value){
									$params->elements[$k]->user[$l]->$key = $value;
								}
							}
						}
						if(!isset($params->elements[$k]->user[$l]->cust_id))
							$params->elements[$k]->user[$l]->cust_id = '';
					}
				}
			}
			$params->formatExport = $formatExport;
			$params->path = $path;
			$params = $massactionClass->sortResult($params->table,$params);

			$db = JFactory::getDBO();

			// We create the csv file columns
			$columns = array();
			if($custId){
				//$columns[] = 'cust_id';
				$cust_id = array('cust_id' => 'cust_id');
				$action['user'] = $cust_id+$action['user'];
			}

			$i = 1;
			foreach($action as $k => $type){

				if($i == 3){
					$billingData['billing_name'] = $columns[] = 'billing_name';
					foreach($type as $header){
						$billingData['billing_'.$header] = $columns[] = 'billing_'.$header;
					}
					$shippingData['shipping_name'] = $columns[] = 'shipping_name';
					foreach($type as $header){
						$shippingData['shipping_'.$header] = $columns[] = 'shipping_'.$header;
					}
				}else{
					foreach($type as $header){
						$columns[] = $header;
					}
				}
				$i++;
			}
			$action['address'] =array_merge($billingData,$shippingData);

			// We create each csv lines with order data
			$lines = array();
			foreach($params->elements as $i => $element){
				$content = array();
				foreach($element->order_product as $j => $product){
					foreach($action as $k => $actionData){
						foreach($actionData as $l => $actionColumn){
							if($k == 'user'){ //!\\ Handle the dates
								$data = $element->$k;
								if(in_array($l,$this->massaction->datecolumns) && is_numeric($data[0]->$l)){
									$data[0]->$l = date('n/d/Y G:i',$data[0]->$l);
								}
								$content[$l] = $data[0]->$l;
							}elseif($k == 'order'){ //!\\ Handle the dates
								if(in_array($l,$this->massaction->datecolumns) && is_numeric($element->$l)){
									$element->$l = date('n/d/Y G:i',$element->$l);
								}
								if($l == 'order_discount_price'){
									$element->$l = @$element->$l->value;
								}
								$content[$l] = $element->$l;
							}elseif($k == 'address'){
								$data = $element->$k;
								$billingId = 0;
								$shippingId = null;
								foreach($data as $m => $address){
									if($address->address_id == $params->elements[$i]->order_billing_address_id){
										$billingId = $m;
									}else{
										$shippingId = $m;
									}
								}
								if($shippingId == null)
									$shippingId = $billingId;
								if(preg_match('#billing_#',$l)){
									$rL = str_replace('billing_','',$l);
									if($l == 'billing_name'){
										$cRL1 = 'address_firstname';
										$cRL2 = 'address_lastname';
										$data[$billingId]->$rL = $data[$billingId]->$cRL1.' '.$data[$billingId]->$cRL2;
									}
									if(preg_match('#state_#',$data[$billingId]->$rL)){
										$data[$billingId]->$rL = str_replace('state_','',$data[$billingId]->$rL);
										$data[$billingId]->$rL = preg_replace('#_[1-9].*#','',$data[$billingId]->$rL);
										$data[$billingId]->$rL = str_replace('_',' ',$data[$billingId]->$rL);
									}
									if(preg_match('#country_#',$data[$billingId]->$rL)){
										$data[$billingId]->$rL = str_replace('country_','',$data[$billingId]->$rL);
										$data[$billingId]->$rL = preg_replace('#_[1-9].*#','',$data[$billingId]->$rL);
										$data[$billingId]->$rL = str_replace('_',' ',$data[$billingId]->$rL);
									}
									$content[$l] = $data[$billingId]->$rL;
								}else{
									$rL = str_replace('shipping_','',$l);
									if($l == 'shipping_name'){
										$cRL1 = 'address_firstname';
										$cRL2 = 'address_lastname';
										$data[$shippingId]->$rL = $data[$shippingId]->$cRL1.' '.$data[$shippingId]->$cRL2;
									}
									if(preg_match('#state_#',$data[$shippingId]->$rL)){
										$data[$shippingId]->$rL = str_replace('state_','',$data[$shippingId]->$rL);
										$data[$shippingId]->$rL = preg_replace('#_[1-9].*#','',$data[$shippingId]->$rL);
										$data[$shippingId]->$rL = str_replace('_',' ',$data[$shippingId]->$rL);
									}
									if(preg_match('#country_#',$data[$shippingId]->$rL)){
										$data[$shippingId]->$rL = str_replace('country_','',$data[$shippingId]->$rL);
										$data[$shippingId]->$rL = preg_replace('#_[1-9].*#','',$data[$shippingId]->$rL);
										$data[$shippingId]->$rL = str_replace('_',' ',$data[$shippingId]->$rL);
									}
									$content[$l] = $data[$shippingId]->$rL;
								}
							}elseif($k == 'order_product'){
								$data = $element->$k;
								$content[$l] = $data[$j]->$l;
							}elseif($k == 'joomla_users'){
								$data = $element->$k;
								$content[$l] = $data[0]->$l;
							}
						}
					}
					$lines[] = $content;
				}
			}
			$config = hikashop_config();
			$separator = $config->get('csv_separator',',');
			if(!empty($path)){
				$path = str_replace('.csv','-'.date('d-m-y-H').'h.csv',$path);
				$fp = fopen($path, 'w');
				fputcsv($fp, $columns,$separator);
				foreach ($lines as $line) {
						fputcsv($fp, $line,$separator);
				}
				fclose($fp);
			}else{
				$export = hikashop_get('helper.spreadsheet');
				switch($params->formatExport){
					case 'csv':
						$format = $config->get('export_format','csv');
						$force_quote = $config->get('csv_force_quote',1);
						$decimal_separator = $config->get('csv_decimal_separator','.');
						$export->init($format, 'hikashop_export', $separator, $force_quote, $decimal_separator);
						break;
					case 'xls':
						$format = 'xls';
						$export->init($format, 'hikashop_export',';',true);
						break;
				}
				$export->writeLine($columns);
				foreach ($lines as $line) {
					$export->writeLine($line);
				}
				$export->send();
			}

			//$massactionClass->_sessionManage($params);
		}
		// If send via email
		if(!empty($email) && !empty($path)){
			$config = hikashop_config();
			$mailClass = hikashop_get('class.mail');
			$content = array('type' => 'csv_export');
			$mail = $mailClass->get('massaction_notification',$content);
			$mail->subject = JText::_('MASS_CSV_EMAIL_SUBJECT');
			$mail->html = '1';
			$csv = new stdClass();
			$csv->name = JText::_('MASS_CSV_EMAIL_FILE_NAME');
			$csv->filename = $path;
			$csv->url = $path;
			$mail->attachments = array($csv);
			$mail->dst_name = '';
			$mail->dst_email = explode(',',$email);
			$mailClass->sendMail($mail);
		}
	}

}